// Angular
import * as wjcGridSheet from 'wijmo/wijmo.grid.sheet';
import * as wjcInput from 'wijmo/wijmo.input';
import * as wjcGrid from 'wijmo/wijmo.grid';
import * as wjcCore from 'wijmo/wijmo';

import { Component, EventEmitter, Inject, enableProdMode, ViewChild, NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { BrowserModule } from '@angular/platform-browser';
import { WjGridSheetModule } from 'wijmo/wijmo.angular2.grid.sheet';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
import { DataSvc } from './data.service';

'use strict';

// The Explorer application root component.
@Component({
    selector: 'my-app',
    templateUrl: './app.component.html'
})
export class AppComponent {
    protected dataSvc: DataSvc;
    data: any[];
    flag : boolean;

    // references FlexSheet named 'flexSheet' in the view
    @ViewChild('flexSheetIntro') flexSheetIntro: wjcGridSheet.FlexSheet;
    public gridHeight : number = 50;

    constructor(@Inject(DataSvc) dataSvc: DataSvc) {
        this.dataSvc = dataSvc;
        this.data = dataSvc.getData(100);
    }

    flexSheetInit(flexSheetIntro: wjcGridSheet.FlexSheet) {
        var self = this;

        if (flexSheetIntro) {
            flexSheetIntro.deferUpdate(() => {
                flexSheetIntro.selectedSheetIndex = 0;
                flexSheetIntro.selectedSheet.itemsSource = this.data;
                self._initDataMapForBindingSheet(flexSheetIntro);
            });
        }
    }

    public loadedRows(s: any, e: any) {
        let height = 0;
        for (let i = 0; i < s.rows.length; i++) {
            height += s.rows[i].renderHeight;
        }
        // add tabholder height
        height += 20;
        s.hostElement.style.height = height + 'px';
    }

    public cellEditEnding(event: any): void {
        console.log("cellEditEnding");
       // this.flexSheetIntro.scrollIntoView(80,-1);
        // let rc = this.flexSheetIntro.getCellBoundingRect(100, 0, true);
        // this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
        this.flag = true;
    }

    public updatedView(e: any): void {
        console.log("cellEditEnding");
       // this.flexSheetIntro.scrollIntoView(80,-1);
        //let rc = this.flexSheetIntro.getCellBoundingRect(100, 0, true);
        if(this.flag)
        {
            // var rc =  this.flexSheetIntro.cells.getCellBoundingRect(100, 0, true);
            // this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
            this.flexSheetIntro.scrollIntoView(this.flexSheetIntro.selection.row,-1);
            this.flag = false;
        }
        //this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
    }

    // initialize the dataMap for the bound sheet.
    private _initDataMapForBindingSheet(flexSheet: any) {
        var column;

        if (flexSheet) {
            column = flexSheet.columns.getColumn('countryId');
            if (column && !column.dataMap) {
                column.dataMap = this._buildDataMap(this.dataSvc.countries);
            }
            column = flexSheet.columns.getColumn('productId');
            if (column && !column.dataMap) {
                column.dataMap = this._buildDataMap(this.dataSvc.products);
            }
        }
    }

    // build a data map from a string array using the indices as keys
    private _buildDataMap(items: any) {
        var map = [];
        for (var i = 0; i < items.length; i++) {
            map.push({ key: i, value: items[i] });
        }
        return new wjcGrid.DataMap(map, 'key', 'value');
    }
}